<template>
  <v-card>
    <v-card-title class="ma-0 px-2 pl-2 py-0">
          <span :class="taskClass">{{task.title}}</span>
          <v-spacer></v-spacer>
          <IconButton
            class="ma-0"
            :tip="task.checked ? 'Uncheck task' : 'Check task'"
            :iconName="!task.checked ? 'check_box_outline_blank' : 'check_box'"
            :flat=true
            :small=true
            :color="!task.checked ? 'grey' : 'green'"
            :datas=task
            eventName="edit"
            v-on:edit="checkTask()"
          />
          <IconButton
            v-if="$store.getters['isMobile']"
            class="ma-0 pa-0"
            tip="Edit task"
            iconName="settings"
            :flat=true
            :small=true
            color="primary"
            :datas=task
            eventName="edit"
            v-on:edit="sendEvent('askAction', $event)"
          />
    </v-card-title>
    <v-divider class="" v-if="task.description && $store.getters['showDescription']"></v-divider>
    <v-card-text class="my-1 py-1" v-if="task.description && $store.getters['showDescription']">
      <v-textarea
          class="mt-0 pt-0"
          no-resize
          readonly
          v-model="task.description"
        ></v-textarea>
      </v-card-text>
    <v-divider v-if="!$store.getters['isMobile']" ></v-divider>
    <v-card-actions v-if="!$store.getters['isMobile']">
      Last update : {{task.lastUpdate | moment('D/MM/YYYY') }}
      <v-spacer ></v-spacer>
      <IconButton
      class="mr-4"
        tip="Edit task"
        iconName="settings"
        :flat=true
        :small=true
        color="primary"
        :datas=task
        eventName="edit"
        v-on:edit="sendEvent('editTask', $event)"
      />
      <IconButton
      class="ml-4"
        tip="Delete task"
        iconName="delete"
        :flat=true
        :small=true
        color="error"
        :datas=task
        eventName="delete"
        v-on:delete="sendEvent('deleteTask', $event)"
      />
    </v-card-actions>
  </v-card>
</template>

<script>
import IconButton from '@/components/Buttons/IconButton'
import TaskService from '@/services/TaskService'
import ErrorService from '@/services/ErrorService'

export default {
  name: 'Price',
  props: {
    task: {
      type: Object,
      required: true
    }
  },
  components: {
    IconButton
  },
  computed: {
    taskClass: function () {
      return this.$store.getters['isMobile'] ? 'ma-0 pa-0 my-2 py-0' : 'headline ma-0 pa-0 my-2 py-0'
    }
  },
  data: () => ({
    taskService: new TaskService(),
    errorService: new ErrorService()
  }),
  methods: {
    checkTask: function () {
      this.task.checked = !this.task.checked
      this.taskService.editTask(this.task).then(() => {
        this.$store.commit('changeNbCompletedTaskToListToLoad', (this.task.checked ? 1 : -1))
        this.$emit('refresh')
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.task.checked = !this.task.checked
      })
    },
    sendEvent: function (name, task) {
      this.$emit(name, task)
    },
    askAction: function (task) {
      this.askActionTask = task
      this.askActionDialog = true
    }
  }
}
</script>
